package com.gic.haoban.manage.web.controller;

import java.util.List;

import com.gic.haoban.common.utils.GlobalVar;
import com.gic.haoban.manage.web.anno.IgnoreLogin;
import com.gic.wechat.api.service.qywx.QywxSuiteApiService;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.RestController;

import com.gic.haoban.common.utils.HaobanResponse;
import com.gic.haoban.manage.api.dto.ApplicationDTO;
import com.gic.haoban.manage.api.service.ApplicationApiService;
import com.gic.haoban.manage.web.errCode.HaoBanErrCode;

@RestController
public class ApplicationController extends WebBaseController{
	private static final Logger log = LogManager.getLogger(ApplicationController.class);
	@Autowired
	private ApplicationApiService applicationApiService;
	@Autowired
	private QywxSuiteApiService qywxSuiteApiService;
	
	@RequestMapping("application-list")
	public HaobanResponse applicationList() {
		
		List<ApplicationDTO> list = applicationApiService.listApplication();
		return resultResponse(HaoBanErrCode.ERR_1,list);
	}

	@RequestMapping("get-auth-url")
	public HaobanResponse getAuthUrl(){
		//String suiteId = GlobalVar.ctxPropertiesMap.get("suiteId");
		String suiteId = "ww7d6566614055cf27";
		log.info("应用ID：{}", suiteId);
		String redictUrl = "http://gicdev.demogic.com/haoban-manage3-web/callback";
		String authorizationUrl = this.qywxSuiteApiService.getGrantAuthorizationUrl(suiteId, redictUrl);
		return resultResponse(HaoBanErrCode.ERR_1, authorizationUrl);
	}

	@RequestMapping("callback")
	@IgnoreLogin
	public HaobanResponse callback(String code){
		String suiteId = String suiteId = "ww7d6566614055cf27";
		String result = this.qywxSuiteApiService.corpAuth(suiteId, code);
		return resultResponse(HaoBanErrCode.ERR_1, result);
	}

}
